<?php
if ( ! class_exists( 'Cultural_Festival_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Cultural_Festival_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Cultural_Festival_Plugin_Activation_WPElemento_Importer {

        private static $cultural_festival_instance;
        public $cultural_festival_action_count;
        public $cultural_festival_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$cultural_festival_instance) ) {
            self::$cultural_festival_instance = new self();
          }
          return self::$cultural_festival_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'cultural_festival_recommended_plugins', array($this, 'cultural_festival_recommended_elemento_importer_plugins_array') );

            $cultural_festival_actions                   = $this->cultural_festival_get_recommended_actions();
            $this->cultural_festival_action_count        = $cultural_festival_actions['count'];
            $this->cultural_festival_recommended_actions = $cultural_festival_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function cultural_festival_recommended_elemento_importer_plugins_array($cultural_festival_plugins){
            $cultural_festival_plugins[] = array(
                    'name'     => esc_html__('Mizan Demo Importor', 'cultural-festival'),
                    'slug'     =>  'mizan-demo-importer',
                    'function' => 'Mizan_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the Mizan Demo Importor plugin for importing the demo content with Elementor.', 'cultural-festival'),               
            );
            return $cultural_festival_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'cultural-festival-plugin-activation-script', esc_url(get_template_directory_uri()) . '/inc/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('cultural-festival-plugin-activation-script', 'cultural_festival_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'cultural-festival'),
                    'activating' => esc_html__('Activating', 'cultural-festival'),
                    'error' => esc_html__('Error', 'cultural-festival'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=mizan-demo-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=mizandemoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'cultural-festival-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function cultural_festival_get_recommended_actions() {

            $cultural_festival_act_count  = 0;
            $cultural_festival_actions_todo = get_option( 'recommending_actions', array());

            $cultural_festival_plugins = $this->cultural_festival_get_recommended_plugins();

            if ($cultural_festival_plugins) {
                foreach ($cultural_festival_plugins as $cultural_festival_key => $cultural_festival_plugin) {
                    $cultural_festival_action = array();
                    if (!isset($cultural_festival_plugin['slug'])) {
                        continue;
                    }

                    $cultural_festival_action['id']   = 'install_' . $cultural_festival_plugin['slug'];
                    $cultural_festival_action['desc'] = '';
                    if (isset($cultural_festival_plugin['desc'])) {
                        $cultural_festival_action['desc'] = $cultural_festival_plugin['desc'];
                    }

                    $cultural_festival_action['name'] = '';
                    if (isset($cultural_festival_plugin['name'])) {
                        $cultural_festival_action['title'] = $cultural_festival_plugin['name'];
                    }

                    $cultural_festival_link_and_is_done  = $this->cultural_festival_get_plugin_buttion($cultural_festival_plugin['slug'], $cultural_festival_plugin['name'], $cultural_festival_plugin['function']);
                    $cultural_festival_action['link']    = $cultural_festival_link_and_is_done['button'];
                    $cultural_festival_action['is_done'] = $cultural_festival_link_and_is_done['done'];
                    if (!$cultural_festival_action['is_done'] && (!isset($cultural_festival_actions_todo[$cultural_festival_action['id']]) || !$cultural_festival_actions_todo[$cultural_festival_action['id']])) {
                        $cultural_festival_act_count++;
                    }
                    $cultural_festival_recommended_actions[] = $cultural_festival_action;
                    $cultural_festival_actions_todo[]        = array('id' => $cultural_festival_action['id'], 'watch' => true);
                }
                return array('count' => $cultural_festival_act_count, 'actions' => $cultural_festival_recommended_actions);
            }

        }

        public function cultural_festival_get_recommended_plugins() {

            $cultural_festival_plugins = apply_filters('cultural_festival_recommended_plugins', array());
            return $cultural_festival_plugins;
        }

        public function cultural_festival_get_plugin_buttion($slug, $name, $function) {
                $cultural_festival_is_done      = false;
                $cultural_festival_button_html  = '';
                $cultural_festival_is_installed = $this->is_plugin_installed($slug);
                $cultural_festival_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $cultural_festival_is_activeted = (class_exists($function)) ? true : false;
                if (!$cultural_festival_is_installed) {
                    $cultural_festival_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $cultural_festival_plugin_install_url = wp_nonce_url($cultural_festival_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $cultural_festival_button_html        = sprintf('<a class="cultural-festival-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($cultural_festival_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'cultural-festival'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'cultural-festival')
                    );
                } elseif ($cultural_festival_is_installed && !$cultural_festival_is_activeted) {

                    $cultural_festival_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($cultural_festival_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $cultural_festival_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $cultural_festival_button_html = sprintf('<a class="cultural-festival-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($cultural_festival_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'cultural-festival'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'cultural-festival')
                    );
                } elseif ($cultural_festival_is_activeted) {
                    $cultural_festival_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'cultural-festival'));
                    $cultural_festival_is_done     = true;
                }

                return array('done' => $cultural_festival_is_done, 'button' => $cultural_festival_button_html);
            }
        public function is_plugin_installed($slug) {
            $cultural_festival_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $cultural_festival_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($cultural_festival_installed_plugins[$cultural_festival_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $cultural_festival_keys = array_keys($this->get_installed_plugins());
            foreach ($cultural_festival_keys as $cultural_festival_key) {
                if (preg_match('|^' . $slug . '/|', $cultural_festival_key)) {
                    return $cultural_festival_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Cultural_Festival_Plugin_Activation_WPElemento_Importer::get_instance();